<!DOCTYPE html>
<html>
  <head>
       <meta charset="UTF-8">
       <script src="https://unpkg.com/react@15/dist/react.min.js"></script>
       <script src="https://unpkg.com/react-dom@15/dist/react-dom.min.js"></script>
       <script src="https://cdnjs.cloudflare.com/ajax/libs/babel-standalone/6.24.0/babel.js"></script>


  </head>
  <body>
      <div id="root"></div>
      <script type="text/babel">

          class Fetd extends React.Component
          {
              constructor(props) {
                  super(props)

                  this.style = {
                      border: '1px solid #dddddd',
                      padding: '8px'
                  }
                  this.style['text-align'] = 'left'
              }

              render() {
                  return <td style = {this.style}>{this.props.value}</td>
              }
          }

          class Fetr extends React.Component
          {
              constructor(props) {
                  super(props)
/*
                  this.style = {
                      [styles.option, {
                          background-color: (
                              (this.props.index % 2) == 0 ? '#dddddd' : '#ffffff') }
                      ]
                  }
 */
              }

              render() {
                  var tds = this.props.cellValues.map(
                      (item, index) => <Fetd value={item}/> )
                  //return <tr style = {this.style}>{tds}</tr>
                  return <tr>{tds}</tr>
              }
          }

          class Fetable extends React.Component
          {
              constructor(props) {
                  super(props)

                  this.style = {
                      width: '100%'
                  }
                  this.style['font-family'] = 'arial, sans-serif'
                  this.style['border-collapse'] = 'collapse'
              }

              render() {
                  console.log('filas is: ', this.props.filas)
                  if (this.props.filas) {
                      var filas = this.props.filas.content.map(
                          (item, index) => { return <Fetr cellValues = {[item.COD_PROVEEDOR, item.ARTICULO, item['MARCA PAIS'], item.UNID, item['P.V.P.']]}/> })
                  } else
                      var filas = null
                  return <table style = {this.style}>{filas}</table>
              }
          }

          function Summary(props) {
              return (
                  <label>
                      Showing {props.total_elements} elements
                  </label>
              )
          }
/*
          function Row(props) {
              return (
                  <div>
                      {props.label}:{" "}
                      {"" + props.value}
                  </div>
              )
          }

          function Detail(props) {
              return (
                  <div>
                      <div>{props.detail_rows ? "Details of clicked item:" : ""}</div>
                      <div>{props.detail_rows}</div>
                  </div>
              );
          }
 */
          class ControlPanel extends React.Component
          {
              constructor(props) {
                  super(props)
                  this.state = { articulo: null,
                                 codigo_proveedor: null,
                                 marca_pais: null,
                                 total_elements: 0,
                                 data: null }
                  this.anyInputHandler = this.anyInputHandler.bind(this)
                  this.inputHandler = this.inputHandler.bind(this)
                  //this.radioHandler = this.radioHandler.bind(this)
                  //this.itemClickedHandler = this.itemClickedHandler.bind(this)
              }

              componentDidMount() {
                  this.inputHandler(0, null);
              }
/*
              itemClickedHandler(event, key) {
                  if (key) {
                      var url = 'https://recruitment-test-api.devsandbox.knetikcloud.com/devices?filter=id:' + key
                      fetch(url)
                          .then(response => response.json())
                          .then(data => {
                              var elements = data.content.map( (item, index) => {
                                  return Object.keys(item).map((p, i) =>
                                      <Row label={p} value={item[p]} />
                                  )
                              });
                              this.setState((prevState, props) => {
                                  return { detail: elements }});
                          });
                  }
              }

              radioHandler(input) {
                  this.inputHandler(3, input);
              }
 */
              anyInputHandler(id, input) {
                  var url = 'http://localhost:3001/search-product?any='
                  if (input)
                          url = url + input
                  console.log('url any', url)
                  fetch(url)
                      .then(response => response.json())
                      .then(data => {
                          if (data && data.content) {
                              this.setState({ total_elements: data.content.length,
                                              data })
                          }});
              }

              inputHandler(id, input) {
                  var url = 'http://localhost:3001/search-product?qry='
                  var articulo = this.state.articulo
                  var codigo_proveedor = this.state.codigo_proveedor
                  var marca_pais = this.state.marca_pais
                  if (id == 1) {
                      if (input)
                          url = url + 'articulo:' + input
                      articulo = input
                      if (codigo_proveedor) {
                          if (input)
                              url = url + '%7C' // pipe
                          url = url + 'codigo_proveedor:' + codigo_proveedor
                      }
                      if (marca_pais) {
                          if (input || codigo_proveedor)
                              url = url + '%7C' // pipe
                          url = url + 'marca_pais:' + marca_pais
                      }
                  } else if (id == 2) {
                      if (input)
                          url = url + 'codigo_proveedor:' + input
                      codigo_proveedor = input
                      if (articulo) {
                          if (input)
                              url = url + '%7C' // pipe
                          url = url + 'articulo:' + articulo
                      }
                      if (marca_pais) {
                          if (input || articulo)
                              url = url + '%7C' // pipe
                          url = url + 'marca_pais:' + marca_pais
                      }
                  } else if (id == 3) {
                      if (input)
                          url = url + 'marca_pais:' + input
                      marca_pais = input
                      if (articulo) {
                          if (input)
                              url = url + '%7C' // pipe
                          url = url + 'articulo:' + articulo
                      }
                      if (codigo_proveedor) {
                          if (input || articulo)
                              url = url + '%7C' // pipe
                          url = url + 'codigo_proveedor:' + codigo_proveedor
                      }
                  }

                  console.log('url', url)
                  fetch(url)
                      .then(response => response.json())
                      .then(data => {
                          if (data && data.content) {
                              this.setState({ articulo: articulo,
                                              codigo_proveedor: codigo_proveedor,
                                              marca_pais: marca_pais,
                                              total_elements: data.content.length,
                                              data })
                          }});
              }

              render() {
                  return (
                      <div>
                          <ControlledInput id = {999} inputHandler = {this.anyInputHandler}/>
                          <br/>
                          <ControlledInput id = {1} label = "Artículo: " inputHandler = {this.inputHandler}/>
                          <br/>
                          <ControlledInput id = {2} label = "Código Proveedor: " inputHandler = {this.inputHandler}/>
                          <ControlledInput id = {3} label = "Marca o País: " inputHandler = {this.inputHandler}/>
                          <Fetable filas = {this.state.data}/>
                          <br/>
                          <Summary total_elements={this.state.total_elements}/>
                      </div>
                  )
              }
          }
/*
          class BoolAnyRadio extends React.Component
          {
              constructor(props) {
                  super(props)
                  this.state = { connected: null }
                  this.valueHandler = this.valueHandler.bind(this)
              }

              valueHandler(e) {
                  this.setState({
                      connected: e.currentTarget.value == "true" ? true : (
                                 e.currentTarget.value == "false" ? false: (
                                 null))
                  }, () => {this.props.radioHandler(this.state.connected) });
              }

              render() {
                  var rows = (
                      <tbody>
                          <tr>
                              <td><input type="radio" name="connected" 
                                         value="true"
                                         checked={this.state.connected === true}
                                         onChange={this.valueHandler} />
                                  Connected
                              </td>
                              <td><input type="radio" name="disconnected" 
                                         value="false"
                                         checked={this.state.connected === false}
                                         onChange={this.valueHandler} />
                                  Disconnected
                              </td>
                              <td><input type="radio" name="any" 
                                         value="null"
                                         checked={this.state.connected === null}
                                         onChange={this.valueHandler} />
                                  Any
                              </td>
                          </tr>
                      </tbody>
                  );
                  return (
                      <table className="table">
                          {rows}
                      </table>
                  );
              }
          }
 */
          class ControlledInput extends React.Component
          {
              constructor(props) {
                  super(props)
                  this.state = { value: "" }
                  this.handleChange = this.handleChange.bind(this)
              }
              handleChange(event) {
                  this.setState({ value: event.target.value })
                  this.props.inputHandler(this.props.id, event.target.value)
              }
              render() {
                  return (
                      <label>
                          {this.props.label}
                          <input onChange = {this.handleChange}/>
                      </label>
                  )
              }
          }
/*
          function ListItem(props) {
              return <li onClick={props.onClick}>Código de proveedor: {props.codigo_proveedor} | Artículo: {props.articulo} | Marca/País: {props.marca_pais} | P.V.P.: {props.pvp}</li>
          }

          class DeviceList extends React.Component
          {
              constructor(props) {
                  super(props)
              }
              render() {
                  if (this.props.items) {
                      var elements = this.props.items.content.map( (item, index) => {
                          return <ListItem key={item.id} onClick={(e) => this.props.itemClickedHandler(e, item.COD_PROVEEDOR)} codigo_proveedor={item.COD_PROVEEDOR} marca_pais={item['MARCA PAIS']} articulo={item.ARTICULO} pvp={item['P.V.P.']}/>
                      })
                  }
                  return <ol>{elements}</ol>
              }
          }
 */

          /*const options = [
            { value: 'chocolate', label: 'Chocolate' },
            { value: 'strawberry', label: 'Strawberry' },
            { value: 'vanilla', label: 'Vanilla' }
          ];

          class Hola extends React.Component {
            state = {
              selectedOption: null,
            }
            handleChange = (selectedOption) => {
              this.setState({ selectedOption });
              console.log(`Option selected:`, selectedOption);
            }
            render() {
              const { selectedOption } = this.state;

              return (
                <Select
                  value={selectedOption}
                  onChange={this.handleChange}
                  options={options}
                />
              );
            }
          }*/

          ReactDOM.render(
              <ControlPanel/>,
              document.getElementById('root')
          )
      </script>
  </body>
</html>
